SystemOrganization addCategory: #SqueakSVNPlugins!

SimpleButtonMorph subclass: #BuildButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!BuildButton class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/4/2008 18:58'!
makeWinBuildButton

	"self makeWinBuildButton"
	| btn |
	btn := self newWithLabel: 'SqueakSVNBauen'.
	btn
		actionSelector: #callBuildBat;
		target: btn;
		openInWorld.! !

!BuildButton methodsFor: 'as yet unclassified' stamp: 'rkrk 4/4/2008 18:57'!
callBuildBat

	OSProcess command: 'buildSqueakSVNPlugin.bat'! !

TextFieldMorph subclass: #SqueakSVNPluginBuilderTool
	instanceVariableNames: 'pluginBuilder text textField transparent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPluginBuilderTool class methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 14:56'!
open

	^ self openIntransparen! !

!SqueakSVNPluginBuilderTool class methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 15:00'!
openIntransparen

	| rec inst |
	inst := self new.
	inst transparent: false.
	rec := RectangleMorph new
		addMorph: inst.
	rec extent:
		300@150;
		color: (Color white) darker;
		openInWorld.
	^ inst! !

!SqueakSVNPluginBuilderTool methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 14:58'!
close

	transparent ifFalse: [^self owner delete].
	^self delete! !

!SqueakSVNPluginBuilderTool methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 15:19'!
createPlugin

	pluginBuilder pathToDefDir: textField contents asString.
	pluginBuilder createPlugin! !

!SqueakSVNPluginBuilderTool methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 15:14'!
initialize
	
	| btn clbtn str |
	super initialize.
	
	pluginBuilder := SqueakSVNPluginBuilder new.
	self contents:  '   SqueakSVNPlugin'.
	self extent: 300@20.
	self color: (Color lightGray) lighter.
	
	clbtn := (SimpleButtonMorph
		newWithLabel: 'x')
			actionSelector: #close;
			target: self.
	self addMorph: clbtn.
	clbtn position: 4@4.
	clbtn extent: 12@12.
	
	btn := ((SimpleButtonMorph
		newWithLabel: 'Create plugin code and def')
			actionSelector: #createPlugin;
			target: self).
	self addMorph: btn.
	btn position: (self width - btn width //2)@90.
	
	str := LabelStringMorph new
		contents: 'Directory of module definiton file:'.
	self addMorph: str.
	str position: 5@35.
	
	textField := TextFieldMorph new.
	textField
		color: Color white;
		position: 10@50;
		extent: 280@20;
		contents: 'path\to\defdir'.
	self addMorph: textField.! !

!SqueakSVNPluginBuilderTool methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 14:55'!
transparent: bool

	transparent := bool! !

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: 'pool ctx callbackBatonOop username password targetString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin class methodsFor: 'translation' stamp: 'cop 4/23/2008 11:25'!
declareCVarsIn: cg

	super declareCVarsIn: cg.

	cg
		var: 'pool' 			declareC: 'apr_pool_t *pool';
		var: 'ctx' 			declareC: 'svn_client_ctx_t *ctx';
		var: 'username'		declareC: 'char username[STRSIZE]';
		var: 'password'		declareC: 'char password[STRSIZE]';
		var: 'targetString'	declareC: 'char targetString[STRSIZE]'.
				
	cg
		addHeaderFile: '"svn_string.h"';
		addHeaderFile: '"svn_client.h"';
		addHeaderFile: '"svn_cmdline.h"';
		addHeaderFile: '"svn_wc.h"';
		addHeaderFile: '"svn_pools.h"
#define STRSIZE 1024'.	"Another way how to use define?"! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 4/27/2008 14:47'!
aprArrayFromOopStrings: aOopCollectionOfOopTargets using: aprPool

	| arraySize arrayPtr copiedTargets temporaryPath |
	self returnTypeC: 'apr_array_header_t *'.
	self
		var: #aprPool 			type: 'apr_pool_t*';
		var: #copiedTargets		declareC: 'apr_array_header_t *copiedTargets';
		var: #arrayPtr 			declareC: 'sqInt *arrayPtr';
		var: #temporaryPath 		declareC: 'char temporaryPath[STRSIZE]';
		var: #arraySize 			declareC: 'int arraySize'.
	
	
	self writeTextToOutputFile: 'aprArrayFromOopStrings: Entered'.
	arraySize := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	arrayPtr := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	copiedTargets := self cCode: 'apr_array_make (aprPool, arraySize, sizeof (char*))'.
	0 to: arraySize - 1 do: [:index |
		self
			copyOopString: (arrayPtr at: index)
			toCString: temporaryPath
			ofLength: (self cCode: 'STRSIZE').
		self cCode: 'APR_ARRAY_PUSH (copiedTargets, char*) = apr_pstrdup(aprPool, temporaryPath)'].
	self writeTextToOutputFile: 'aprArrayFromOopStrings: Finished'.
	^ copiedTargets! !

!SqueakSVNPlugin methodsFor: 'svn authentication' stamp: 'rt 4/22/2008 13:45'!
authenticateContext: localCtx InPool: localPool

	| provider providers |
	self
		var: #localCtx 	type: 'svn_client_ctx_t*';
		var: #localPool 	type: 'apr_pool_t*';
		var: #provider	declareC: 'svn_auth_provider_object_t *provider';
		var: #providers	declareC: 'apr_array_header_t *providers'.

	self writeTextToOutputFile: '#authenticateContext:InPool: Entered'.
	providers := self cCode: 'apr_array_make (localPool, 4, sizeof (svn_auth_provider_object_t *))'.
	
	"password prompt provider"
	self cCode: 'svn_auth_get_simple_prompt_provider (&provider,
										 pwdCallbackForCredentialEmptyBatonRealmUsernameMaySaveIndicatorAndPool,
										 NULL,
										 0, localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.

	"username prompt provider"
	self cCode: 'svn_auth_get_username_prompt_provider (&provider,
										 usrCallbackForCredentialEmptyBatonRealmMaySaveIndicatorAndPool,
										 NULL,
										 0, localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"provider for saved password"
	self cCode: 'svn_client_get_simple_provider (&provider, localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"provider for saved username"
	self cCode: 'svn_client_get_username_provider (&provider, localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	self cCode: 'svn_auth_open (&(localCtx)->auth_baton, providers, localPool)'.
	self writeTextToOutputFile: '#authenticateContext:InPool: Exit'.! !

!SqueakSVNPlugin methodsFor: 'svn authentication' stamp: 'rt 4/21/2008 17:08'!
authenticateWithName: aUsername andPassword: aPassword

	self export:true.
	self primitive: 'authenticateWithNameAndPassword' parameters: #(Oop Oop).
	
	self writeTextToOutputFile: '#authenticateWithName:AndPassword: start authentication'.
	self
		copyOopString: aUsername
		toCString: username
		ofLength: (self cCode: 'STRSIZE').
	self
		copyOopString: aPassword
		toCString: password
		ofLength: (self cCode: 'STRSIZE').! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'cop 5/1/2008 09:48'!
blameCallback: baton Line: lineNo Revision: revision Author: author Date: date Line: line Pool: localPool

	| arr aTime timeUtf8 timeStr revStr authorStr lineStr lineNoStr tempPtr |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton			type: 'void *';
		var: #lineNo 		type: 'apr_int64_t';
		var: #revision 		type: 'svn_revnum_t';
		var: #author 		type: 'const char *';
		var: #date 			type: 'const char *';
		var: #line 			type: 'const char *';
		var: #localPool		type: 'apr_pool_t *'.
	self
		var: #arr			declareC: 'apr_array_header_t *arr';
		var: #aTime			declareC: 'apr_time_t aTime';
		var: #timeUtf8		declareC: 'char *timeUtf8';
		var: #timeStr		declareC: 'char *timeStr';
		var: #revStr		declareC: 'char *revStr';
		var: #authorStr		declareC: 'char *authorStr';
		var: #lineStr		declareC: 'char *lineStr';
		var: #lineNoStr		declareC: 'char *lineNoStr';
		var: #tempPtr		declareC: 'char *tempPtr'.
		
	self writeTextToOutputFile: 'Entered blame callback'.
	arr := self cCode: '(apr_array_header_t*)baton'.
		
	(self cCode: 'SVN_IS_VALID_REVNUM(revision)')
		ifTrue: [ revStr := self cCode: 'apr_psprintf(localPool, "%d", revision)']
		ifFalse: [ revStr := ''].
		
	tempPtr := self cCode: 'apr_pstrdup(localPool, revStr)'.
	self cCode: 'APR_ARRAY_PUSH( arr, char* ) = tempPtr'.
		
	tempPtr := self cCode: 'apr_pstrdup(localPool, authorStr)'.
	self cCode: 'APR_ARRAY_PUSH( arr, char* ) = tempPtr'.
		
	date
		ifFalse: [timeStr := '']
		ifTrue: [ self cCode: 'SVN_ERR(svn_time_from_cstring(&aTime, date, localPool))'.
			timeUtf8 := self cCode: '(char*)svn_time_to_human_cstring(aTime, localPool)'.
			self cCode: 'SVN_ERR(svn_cmdline_cstring_from_utf8(&timeStr, timeUtf8, localPool))'].
		
	tempPtr := self cCode: 'apr_pstrdup(localPool, timeStr)'.
	self cCode: 'APR_ARRAY_PUSH( arr, char* ) = tempPtr'.
		
	lineNo > 0
		ifTrue: [ lineNoStr := self cCode: 'apr_psprintf(localPool, "%d", lineNo)']
		ifFalse: [ lineNoStr := ''].
		
	tempPtr := self cCode: 'apr_pstrdup(localPool, lineNoStr)'.
	self cCode: 'APR_ARRAY_PUSH( arr, char* ) = tempPtr'.
		
	tempPtr := self cCode: 'apr_pstrdup(localPool, lineStr)'.
	self cCode: 'APR_ARRAY_PUSH( arr, char* ) = tempPtr'.
	
	self writeTextToOutputFile: 'Leave blame callback'.
		
	^self cCode: 'SVN_NO_ERROR'.! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 3/13/2008 22:51'!
callocWrapper: count size: objectSize
	"Copied from OSProcessPlugin"
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'calloc(count, objectSize)'! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'rt 4/25/2008 14:42'!
commitCallbackToSetMessage: logMessage
	AndMessageFile: messageFile
	FromItems: commitItems
	AndMessageBaton: batonWithMessage
	WithPool: callbackPool
	"copy the log message from the baton to the real log message used by svn"
	
	self
		var: #logMessage 			type: 'const char **';
		var: #messageFile 			type: 'const char **'; "a path"
		var: #commitItems 			type: 'const apr_array_header_t *';
		var: #batonWithMessage 	type: 'void *';
		var: #callbackPool 			type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.

	self writeTextToOutputFile: '#commitCallbackToSetMessage: Entered'.
	
	self cCode: '*logMessage = (const char *) batonWithMessage'.	
	self cCode: '*messageFile = NULL'.
	
	self writeTextToOutputFile: (self cCode: '*logMessage').
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rt 4/1/2008 13:37'!
commitLogCountingCallbackWithBaton: baton
	ForPaths: changedPaths
	AtRevision: revision
	ForAuthor: author
	AndDate: date
	AndWithMessage: message
	AllAllocatedInPool: callbackPool

	| num |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton				type: 'void *';
		var: #changedPaths		type: 'apr_hash_t *';
		var: #revision			type: 'svn_revnum_t';
		var: #author			type: 'const char *';
		var: #date				type: 'const char *';
		var: #message			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *';
		var: #num				declareC: 'int* num'.

	self writeTextToOutputFile: 'commitLogCountingCallback entered'.
	num := self cCode: '(int*)baton'.
	self cCode: '*num = *num + 1'.
	^ self cCode: 'SVN_NO_ERROR'.! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'rt 4/7/2008 18:30'!
computeStatusForEntryInBaton: baton
	WithPath: path
	Dirent: dirent
	Lock: lock
	AbsPath: absPath
	AndPool: callbackPool
	
	| hashFromBaton newValue |
	self
		var: #baton 			type: 'void *';
		var: #path 				type: 'const char *';
		var: #dirent 			type: 'const svn_dirent_t *';
		var: #lock 				type: 'const svn_lock_t *';
		var: #absPath 			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *';
		var: #hashFromBaton	declareC: 'apr_hash_t *hashFromBaton';
		var: #newValue			declareC: 'svn_dirent_t *newValue'.
	self returnTypeC: 'svn_error_t *'.
	
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Entered'.
	self writeTextToOutputFile: path.
	
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Getting'.
	hashFromBaton := self cCode: '*((apr_hash_t**)baton)'.
	(self cCode: '(int) apr_hash_get( hashFromBaton , path , APR_HASH_KEY_STRING )')
		ifFalse: [^ self cCode: 'SVN_NO_ERROR'].
		
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Setting'.
	newValue := self cCode: 'svn_dirent_dup( dirent, apr_hash_pool_get (hashFromBaton) ) '.
	(self cCode: 'apr_hash_set(
		hashFromBaton,
		(void*)path,
		APR_HASH_KEY_STRING,
		(void*) newValue)').
	(self cCode: 'dirent->kind == svn_node_dir')
		ifTrue: [self writeTextToOutputFile: 'could be a project']
		ifFalse: [self writeTextToOutputFile: 'no project with this name'].
	
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'cop 4/30/2008 12:37'!
copyCString: cString toOopString: oopString

	| cStrLength oopStrLength |
	self returnTypeC: 'void'.
	self
		var: #cString 		type: 'const char*';
		var: #cStrLength 	declareC: 'size_t cStrLength';
		var: #oopStrLength 	declareC: 'size_t oopStrLength'.
	
	self
		writeTextToOutputFile: 'copyCString:toOopString: entered';
		writeTextToOutputFile: cString.
	
	cStrLength := self strlen: cString.
	oopStrLength := interpreterProxy stSizeOf: oopString.
	
	(oopStrLength < cStrLength)
		ifTrue: [self
				writeTextToOutputFile: 'Tried to copy a cString to an oopString';
				writeTextToOutputFile: cString;
				writeTextToOutputFile: 'Attempt failed because the cString is longer than the oopString'.
			interpreterProxy success: false].
	
	self
		st: (interpreterProxy arrayValueOf: oopString)
		rn: cString
		cpy: cStrLength.

	"interpreterProxy storePointer: cStrLength ofObject: oopString withValue: (self cCode: '''\0''')."! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/17/2008 19:56'!
copyKeyAndValueOfAprHashIndex: hi in: arrayOop at: i
	
	|  propkey key propval value keyLen newCString |
	self
		var: #hi 			type: 'apr_hash_index_t *';
		var: #arrayOop  	type: 'sqInt';
		var: #i 			type: 'int';
		var: #key 		declareC: 'const void *key';
		var: #keyLen 		declareC: 'apr_ssize_t keyLen';
		var: #value 		declareC: 'void *value';
		var: #propkey 	declareC: 'const char *propkey';
		var:  #propval	declareC: 'svn_string_t *propval';
		var: #newCString  declareC: 'const char *newCString'.
		
	self cCode: 'apr_hash_this(hi, &key, &keyLen, &value)'.
	propkey := self cCoerce: key to: 'const char *'.
	propval := self cCoerce: value to: 'svn_string_t *'.

	self writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: ---------------------BEGIN------------------------'.
	"interpreterProxy
		storePointer: i
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: propkey
			ofSize: keyLen)."
	self
		putString: key
		in: arrayOop
		at: i.
	"interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: i ofObject: arrayOop)
	goes beyond the size of the char* in newSqueakString. Is this a problem?"
	"interpreterProxy
		storePointer: i + 1
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: (self cCode: 'propval->data')
			ofSize: (self cCode: 'propval->len'))."
	self
		putString: (self cCode: 'propval->data')
		in: arrayOop
		at: i + 1.
	
	"for debug output only"
	"newCString := interpreterProxy arrayValueOf: (interpreterProxy
							fetchPointer: i
							ofObject: arrayOop)."

	"self
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at:';
		writeTextToOutputFile: newCString;
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: newCString);
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: keyLen."
		"writeTextToOutputFile: (interpreterProxy arrayValueOf: (arrayPtr at: i+1));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i +1)));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: (self cCode: 'propval->len')."

	"description: '#convertCStringOfSize:toOop: has failed'."
	"self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i))) = keyLen.
	self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i + 1))) = (self cCode: 'propval->len')."! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/21/2008 01:00'!
copyOopString: oopString toCString: cString ofLength: cStringLength

	self returnTypeC: 'void'.
	self var: cString type: 'char*'.
	
	((interpreterProxy stSizeOf: oopString) > cStringLength)
		ifTrue: [self
				writeTextToOutputFile: 'Tried to copy an oopString into a cStrign';
				writeTextToOutputFile: (interpreterProxy arrayValueOf: oopString);
				writeTextToOutputFile: 'Attempt failed because the oopString is longer than the cString'.
			interpreterProxy success: false].
	self
		st: cString
		rn: (interpreterProxy arrayValueOf: oopString)
		cpy: (interpreterProxy stSizeOf: oopString).
	cString at: (interpreterProxy stSizeOf: oopString) put: (self cCode: '''\0''').! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/8/2008 23:45'!
dummyCallbackWithBaton: baton Path: path Info: info Pool: callbackPool
	"should not need it any longer"

	self
		var: #baton 		type: 'void*';
		var: #path 			type: 'const char*';
		var: #info 			type: 'const svn_info_t*';
		var: #callbackPool 	type: 'apr_pool_t*'.
	self returnTypeC: 'svn_error_t*'.
	self writeTextToOutputFile: '#dummyCallback: info requested'.
	^self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/6/2008 20:31'!
forRequiresAuthRequestPreparePool: localPool
	AndCtx: localCtx
	StoreInvocationtNotificationIn: invocationNotif
	
	| providers provider |
	self
		var: #localPool 			type: 'apr_pool_t**';
		var: #localCtx 			type: 'svn_client_ctx_t**';
		var: #invocationNotif 	type: 'int*';
		var: #providers			declareC: 'apr_array_header_t *providers';
		var: #provider			declareC: 'svn_auth_provider_object_t *provider'.
					
	providers := self cCode: 'apr_array_make (*localPool, 2, sizeof (svn_auth_provider_object_t *))'.
		
	"password needed"
	self cCode: 'svn_auth_get_simple_prompt_provider (
		&provider,
		invocationCallbackForCredentialNotificationBatonRealmUsernameMaySaveIndicatorAndPool,
		(void*) invocationNotif,
		0, *localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"username needed"
	self cCode: 'svn_auth_get_username_prompt_provider (
		&provider,
		invocationCallbackForCredentialNotificationBatonRealmMaySaveIndicatorAndPool,
		(void*) invocationNotif,
		0, *localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"Register the auth-providers into the context's auth_baton."
	self cCode: 'svn_auth_open (&(*localCtx)->auth_baton, providers, *localPool)'.! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'cop 4/30/2008 11:57'!
freeLocalPool: localPool 

	self returnTypeC: 'void'.
	self static: true.
	self var: localPool type: 'apr_pool_t**'.
	self writeTextToOutputFile: 'free a local pool'.
	self cCode: 'svn_pool_destroy(*localPool)'.
	self writeTextToOutputFile: 'local pool freed'.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'cop 5/1/2008 09:47'!
getBlameLines: localPool Context: localCtx Target: target Numbers: numberOfLines Array: returnArray

	| i err tempString truePath currentRevision endRevision startRevision diffOptions arr ignoreMIMEtype |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #localPool			type: 'apr_pool_t *';
		var: #localCtx			type: 'svn_client_ctx_t *';
		var: #target 			type: 'char *';
		var: #numberOfLines 	type: 'int *';
		var: #returnArray 		type: 'char ***'.
	self
		var: #i 					declareC: 'int i';
		var: #err 				declareC: 'svn_error_t *err';
		var: #tempString		declareC: 'char* tempString';
		var: #truePath			declareC: 'const char* truePath';
		var: #currentRevision	declareC: 'svn_opt_revision_t currentRevision';
		var: #endRevision		declareC: 'svn_opt_revision_t endRevision';
		var: #startRevision		declareC: 'svn_opt_revision_t startRevision';
		var: #diffOptions		declareC: 'svn_diff_file_options_t * diffOptions';
		var: #arr				declareC: 'apr_array_header_t * arr';
		var: #ignoreMIMEtype	declareC: 'svn_boolean_t  ignoreMIMEtype'.
	
	i := 0.
	ignoreMIMEtype := interpreterProxy booleanValueOf: false.
	
	self
		cCode: 'currentRevision.kind = svn_opt_revision_base';
		cCode: 'startRevision.kind = svn_opt_revision_number';
		cCode: 'startRevision.value.number = 1';
		cCode: 'endRevision.kind = svn_opt_revision_head'.
		
	self writeTextToOutputFile: 'Entered blame'.
	
	arr := self cCode: 'apr_array_make(localPool, 100, sizeof(const char*))'.
	diffOptions := self cCode: 'svn_diff_file_options_create( localPool )'.
	
	self cCode: 'svn_opt_parse_path(&currentRevision, &truePath, target, localPool)'.
	self writeTextToOutputFile: target.
	err := self cCode: 'svn_client_blame3(truePath,
	                      &currentRevision,
	                      &startRevision,
	                      &endRevision,
	                      diffOptions,
	                      ignoreMIMEtype,
	                      blameCallbackLineRevisionAuthorDateLinePool,
	                      arr,  //result: X*5 stringsStruct.strings of char*
	                      localCtx,
	                      localPool)'.
	
	err
		ifTrue: [self handleError: err].
	
	self
		cCode: '*returnArray = (char**) malloc (sizeof(const char*) * arr->nelts)';
		cCode: '*numberOfLines = arr->nelts'.
	
	self cCode: 'for(i = 0; i < arr->nelts;i++)
				(*returnArray)[i] = APR_ARRAY_IDX( arr, i, const char* )'.
	
	self writeTextToOutputFile: 'Leaving blame'.
	
	^err! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'cop 4/30/2008 12:34'!
getCommitLogCallbackWithBaton: baton
	ForPaths: changedPaths
	AtRevision: revision
	ForAuthor: author
	AndDate: date
	AndWithMessage: message
	AllAllocatedInPool: callbackPool
	
	| revisionString authorName dateString logMessage hashPool |

	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton				type: 'void *';
		var: #changedPaths		type: 'apr_hash_t *';
		var: #revision			type: 'svn_revnum_t';
		var: #author			type: 'const char *';
		var: #date				type: 'const char *';
		var: #message			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *'; "use the hash pool !!!!!!"
		var: #revisionString	declareC: 'char *revisionString';
		var: #authorName		declareC: 'const char *authorName';
		var: #dateString		declareC: 'const char *dateString';
		var: #logMessage 		declareC: 'const char *logMessage';
		var: #hashPool			declareC: 'apr_pool_t *hashPool'.

	self writeTextToOutputFile: 'getCommitLogCallback: Entered'.
	hashPool := self cCode: '(*(apr_array_header_t**)baton)->pool'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy revision'.
	revisionString := self cCode: 'apr_psprintf(hashPool, "%ld", revision)'.
	self writeTextToOutputFile: revisionString.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, revisionString)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy author'.
	author
		ifTrue: [authorName := author]
		ifFalse: [authorName :=  self cCode: '"no author"'].
	self writeTextToOutputFile: authorName.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, authorName)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy date'.
	date
		ifTrue: [dateString := date]
		ifFalse: [dateString :=  self cCode: '"no date"'].
	self writeTextToOutputFile: dateString.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, dateString)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy message'.
	message
		ifTrue: [logMessage := message]
		ifFalse: [logMessage := self cCode: '"no message"'].
	self writeTextToOutputFile: logMessage.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, logMessage)'.

	^ self cCode: 'SVN_NO_ERROR'.! !

!SqueakSVNPlugin methodsFor: 'error handling' stamp: 'cop 5/1/2008 09:41'!
handleError: error

	"self static: true;
		export: true."
	self returnTypeC: 'void'.
	self var: error type: 'svn_error_t *'.
	
	self writeTextToOutputFile: 'AEC'.
	self writeIntToOutputFile: (self cCode: 'error->apr_err').
	self writeTextToOutputFile: 'Error occured:'.
	self writeTextToOutputFile: (self cCode: 'error->message').
	"/* svn_handle_error2  seems to break the VM */
		//svn_handle_error2 (err, stderr, TRUE, SqueakSVNWrapper: );"! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'cop 4/30/2008 17:16'!
initialise: localPool In: context 

	self
		var: #localPool 		type: 'apr_pool_t**';
		var: #context 		type: 'svn_client_ctx_t**'.
	
	self initialise: localPool WithParentPool: (self cCode: 'NULL') In: context! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'cop 4/30/2008 17:12'!
initialise: localPool WithParentPool: parentPool In: context 

	| err status |
	self
		var: #localPool 		type: 'apr_pool_t**';
		var: #parentPool 	type: 'apr_pool_t**';
		var: #err 			type: 'svn_error_t*';
		var: #status 		type: 'apr_status_t';
		var: #context 		type: 'svn_client_ctx_t**'.
	
	self writeTextToOutputFile: 'Before svn_cmdline_init'.
	
	"/*********** My svn_cmdline_init ************/"
	status := self cCode: 'apr_initialize()'.
	'/* This has to happen before any pools are created. */'
	self cCode: 'svn_dso_initialize()'.
	
	(self cCode: '0 > atexit(apr_terminate)') ifTrue: [self cCode: 'return'.].
	
	"/* Create a pool for use by the UTF-8 routines.  It will be cleaned
	     up by APR at exit time. */"
	self cCode: '*localPool = svn_pool_create(NULL)'.
	self cCode: 'svn_utf_initialize(*localPool)'.
	err := self cCode: '(svn_error_t*)svn_nls_init()'.
	err ifTrue: [self cCode:  'svn_error_clear(err)'. ].
	
	self writeTextToOutputFile: 'After initializing'.
	
	err := self cCode: '(svn_error_t*)svn_fs_initialize (*localPool)'.
	err ifTrue: [self handleError: err ].
	
	"/* Make sure the ~/.subversion run-time config files exist */"
	err := self cCode: 'svn_config_ensure (NULL, *localPool)'.
	
	err ifTrue: [self handleError: err ].
	
	"/* All clients need to fill out a client_ctx object. */"
	
	"/* Initialize and allocate the client_ctx object. */"
	(err = self cCode: 'svn_client_create_context (context, *localPool)') ifTrue: [self handleError: err ].
	
	"/* Load the run-time config file into a hash */"
	(err = self cCode: 'svn_config_get_config (&((*context)->config), NULL, *localPool)') ifTrue: [self handleError: err ].! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'cop 4/30/2008 17:14'!
initialiseLocalPool: localPool AndLocalContext: localCtx 

	self
		var: #localPool 	type: 'apr_pool_t**';
		var: #localCtx 	type: 'svn_client_ctx_t**'.
			
	self writeTextToOutputFile: 'initialize local pool and local client context'.
	self initialise: localPool WithParentPool: pool In: localCtx.
	self writeTextToOutputFile: 'local pool and local client initialised'.! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'cop 4/30/2008 17:17'!
initialiseModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  initialize of SqueakSVNPlugin'.
	self cCode: 'initialiseIn(&pool, &ctx)'.
	
	self cCode: 'strcpy( username, "DEFAULTUSER\0" )'.
	self cCode: 'strcpy( password, "PASSWORD\0" )'.
	
	self authenticateContext: ctx InPool: pool.
	self writeTextToOutputFile: 'Initialize  of SqueakSVNPlugin complete'.
	^ true
! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'cop 4/30/2008 13:01'!
invocationCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_username_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #username 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	self writeTextToOutputFile: '#invocationCallback: username request'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->may_save = FALSE';
		cCode: '*((int*)baton) = TRUE'.
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/21/2008 15:01'!
invocationCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	Username: aUsername
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #aUsername 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	self writeTextToOutputFile: '#invocationCallback: password request'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->password = ""';
		cCode: '(*cred)->may_save = FALSE';
		cCode: '*((int*)baton) = TRUE'.
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 01:35'!
myStr: destination n: size cpy: source

	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| newString |
	self
		var: 'destination' type: 'char *';
		var: 'source' type: 'const char *';
		var: 'size' type: 'size_t'.
	
	self
		writeTextToOutputFile: 'myStrncpy: Copy String:';
		writeTextToOutputFile: source;
		writeTextToOutputFile: 'myStrncpy: To size';
		writeIntToOutputFile: size.
		
	0 to: size - 1 do: [:i |
		destination at: i put: (source at: i)].
	destination at: size put: (self cCode: '''\0''').
	self
		writeTextToOutputFile: 'myStrncpy: destination';
		writeTextToOutputFile:  destination;
		writeTextToOutputFile: 'myStrncpy: Size';
		writeIntToOutputFile: (self strlen: (destination)).
		
	^ newString! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 14:29'!
printStatusKinds

	self writeTextToOutputFile: 'All status:'.	
		
	self
		writeTextToOutputFile: 'svn_wc_status_none';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_none').
	
	self
		writeTextToOutputFile: 'svn_wc_status_normal:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_normal').
	self
		writeTextToOutputFile: 'svn_wc_status_added:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_added').
	self
		writeTextToOutputFile: 'svn_wc_status_missing:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_missing').
	self
		writeTextToOutputFile: 'svn_wc_status_incomplete:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_incomplete').
	self
		writeTextToOutputFile: 'svn_wc_status_deleted:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_deleted').
	self
		writeTextToOutputFile: 'svn_wc_status_replaced';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_replaced').
	self
		writeTextToOutputFile: 'svn_wc_status_modified';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_modified').
	self
		writeTextToOutputFile: 'svn_wc_status_merged';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_merged').
	self
		writeTextToOutputFile: 'svn_wc_status_conflicted';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_conflicted').
	self
		writeTextToOutputFile: 'svn_wc_status_obstructed';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_obstructed').
	self
		writeTextToOutputFile: 'svn_wc_status_ignored';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_ignored').
	self
		writeTextToOutputFile: 'svn_wc_status_external';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_external').
	self
		writeTextToOutputFile: 'svn_wc_status_unversioned';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_unversioned').! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/21/2008 03:30'!
putAprDate: date in: arrayOop at: index

	| dateString|
	self
		var: #index type: 'int';
		var: #date type: 'apr_time_t';
		var: #dateString declareC: 'char dateString[APR_CTIME_LEN] '.

	date = nil ifTrue: [^ nil].
	self cCode: 'apr_ctime(dateString, date)'.
	self putString: dateString in: arrayOop at: index.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/24/2008 10:52'!
putRevision: revision in: arrayOop at: index

	self
		var: #index type: 'int';
		var: #revision type: 'svn_revnum_t'.

	revision = nil ifTrue: [^ nil].
	self writeIntToOutputFile: revision.
	
	interpreterProxy
		storePointer: index
		ofObject: arrayOop
		withValue: (interpreterProxy integerObjectOf: revision).! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/26/2008 00:36'!
putSchedule: schedule in: arrayOop at: index

	self
		var: #index type: 'int';
		var: #schedule type: 'svn_wc_schedule_t'.

	"schedule = nil ifTrue: [^ nil]."
	schedule = (self cCode: 'svn_wc_schedule_normal')  	ifTrue: [self putString: 'normal' in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_add' )		ifTrue: [self putString: 'add' 	in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_delete' )	ifTrue: [self putString: 'delete' 	in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_replace' )	ifTrue: [self putString: 'replace' in: arrayOop at: index.].! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 13:25'!
putStatus: statusKind in: arrayOop at: index

	self
		var: #index 	type: 'int';
		var: #statusKind 	type: 'int'.

	interpreterProxy
		storePointer: index
		ofObject: arrayOop
		withValue: (interpreterProxy integerObjectOf: statusKind).! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/24/2008 10:51'!
putString: cstring in: arrayOop at: index

	| stringOop |
	self
		var: #cstring type: 'const char *';
		var: #index type: 'int'.
	self	var: #stringOop declareC: 'sqInt stringOop'.

	cstring = nil ifTrue: [^ nil].
	self
		copyCString: cstring
		toOopString: (interpreterProxy
			fetchPointer: index
			ofObject: arrayOop).! !

!SqueakSVNPlugin methodsFor: 'svn authentication' stamp: 'rt 4/22/2008 13:07'!
pwdCallbackForCredential: cred
	EmptyBaton: baton
	Realm: realm
	Username: aUsername
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #aUsername 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	
	self writeTextToOutputFile: 'pwdCallbackForCredential: Entered'.
	
	self
		cCode: '(*cred) = (svn_auth_cred_simple_t *) apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		
		cCode: '(*cred)->username = (char*) apr_pcalloc (localPool, sizeof(char) * STRSIZE)';
		cCode: '(*cred)->username = apr_pstrdup ( localPool, username )';
		
		cCode: '(*cred)->password = (char*) apr_pcalloc (localPool, sizeof(char) * STRSIZE)';
		cCode: '(*cred)->password = apr_pstrdup ( localPool, password )';
		
		cCode: '(*cred)->may_save = TRUE'.
		
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'cop 4/30/2008 12:38'!
repositoryAtUrl: url Exists: boolExists AndNeedsAuthentication: boolNeedsAuth

	| localPool localCtx err revision uuid |
	self
		var: #url 				type: 'char *';
		var: #boolExists 		type: 'int *';
		var: #boolNeedsAuth 	type: 'int *';
		var: #err				declareC: 'svn_error_t *err';
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #uuid 				declareC: 'const char *uuid';
		var: #localPool			declareC: 'apr_pool_t *localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t *localCtx'.
	self returnTypeC: 'int'.
					
	self writeTextToOutputFile: '#repositoryAtUrl:Exists:AndNeedsAuthentication: Entered'.
	self
		cCode: '*boolExists = FALSE';
		cCode: '*boolNeedsAuth = FALSE'.
		
	(self cCode: 'svn_path_is_url(url)')
		ifFalse: [^ self cCode: '1'].
	self
		initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	"prepare authentication system"
	self
		forRequiresAuthRequestPreparePool: (self cCode: '&localPool')
		AndCtx: (self cCode: '&localCtx')
		StoreInvocationtNotificationIn: boolNeedsAuth.
		
	"self cCode: 'revision.kind = svn_opt_revision_head'.
	err := self cCode: 'svn_client_info (
		url,
		&revision,
		&revision,
		dummyCallbackWithBatonPathInfoPool,
		NULL,
		FALSE,
		localCtx, localPool)'."
	err := self cCode: 'svn_client_uuid_from_url (
		&uuid,
		url,
		localCtx, localPool)'.
	(err not or: [self cCode: '*boolNeedsAuth == TRUE'])
		ifTrue: [self cCode: '*boolExists = TRUE'].
	
	self writeTextToOutputFile: '#repositoryAtUrl:Exists:AndNeedsAuthentication: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ self cCode: '1'! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'cop 4/30/2008 13:02'!
shutdownModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  shutdown of SqueakSVNPlugin'.
	"Free the apr memory pool"
	self cCode: 'svn_pool_destroy(pool)'.
	
	self writeTextToOutputFile: 'Shutdown of SqueakSVNPlugin complete'.
	^ true! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/17/2008 20:46'!
sizeForSvnInfoArray

	^ 12! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/21/2008 16:37'!
squeakArrayFromAprHash: aprHash

	| arrayOop i hi arraySize localPool localCtx |
	self
		var: #aprHash 		type: 'apr_hash_t *';
		var: #hi			declareC:  'apr_hash_index_t *hi';
		var: #arraySize 	declareC: 'size_t arraySize';
		var: #i 				declareC: 'int i';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx'.

	self writeTextToOutputFile: '#squeakArrayFromAprHash: Properties read. Copying...'.
	"We need only a pool !!!!!!"
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self writeTextToOutputFile: '#squeakArrayFromAprHash: pool initialized'.
	
	"Store key and values in an array. Therefore this array
	must have twice the size of the hash table"
	self writeIntToOutputFile: (self cCode: '2 * apr_hash_count(aprHash)').
	self writeTextToOutputFile: '#squeakArrayFromAprHash: int printed'.
	arraySize := self cCode: '2 * apr_hash_count(aprHash)'.
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: arraySize.
		
	self writeTextToOutputFile: '#squeakArrayFromAprHash: Start copying properties'.
	
	i := 0.
	hi := self cCode: 'apr_hash_first(localPool, aprHash)'.
	[hi] whileTrue: [
		self
			copyKeyAndValueOfAprHashIndex: hi
			in: arrayOop
			at: i.
		i := i + 2. "Store both key and value in array"
		hi := self cCode: 'apr_hash_next(hi)'].
	
	self writeTextToOutputFile: '#squeakArrayFromAprHash: Finished copying properties'.
	self freeLocalPool: (self cCode: '&localPool').
	^ arrayOop! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/12/2008 13:25'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/20/2008 04:33'!
stringTest02

	| oop ptr aString |

	self export: true.
	self
		"var: #aString declareC: 'char aString[] = /Users/robertkrahn/squeak/squeakSVN/images/svnTests/SVNAwareTestDirectory_71/workingCopy';"
		var: #aString declareC: 'char aString[] = "Haloo"';
		var: #ptr 	declareC: 'char *ptr'.
	
	aString at: 3 put: (self cCode: '''\0''').
	self	writeIntToOutputFile: (self strlen: aString).
	oop := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: (self strlen: aString).
	0 to: (self strlen: aString) - 1 do: [:i |
		self print: '%c\n' f: (aString at: i).
		(self cCoerce: (interpreterProxy arrayValueOf: oop) to: 'char *') at: i put: (aString at: i)].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: oop).
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'cop 4/30/2008 13:17'!
svnAdd: targetOop 
	| err target stringPtr localPool localCtx |
	self export: true.
	self
		var: #target declareC: 'char target[STRSIZE]';
		var: #err declareC: 'svn_error_t *err';
		var: #localPool declareC: 'apr_pool_t* localPool';
		var: #localCtx declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnAdd'
		parameters: #(#Oop ).
	self writeTextToOutputFile: '#svnAdd: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self 
		writeTextToOutputFile: '#svnAdd: copyOopStringToCStringOfLength'.
	self 
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	self writeTextToOutputFile: '#svnAdd: svn_client_add3'.
	err := self 
				cCode: 'svn_client_add3(
			target,
			TRUE,		// recurse
			FALSE,		// force, error on already versioned items
			TRUE,		// no_ignore, we do not use ignore pattern here 
			localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	self writeTextToOutputFile: '#svnAdd: freeLocalPool'.
	self freeLocalPool: (self cCode: '&localPool').
	^ targetOop! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/21/2008 16:43'!
svnAddProperty: propertyOop WithValue: valueOop To: targetOop 
	| property err propval newPropName value target localPool localCtx |
	self export: true.
	self
		var: #property declareC: 'char property[STRSIZE]';
		var: #value declareC: 'char value[STRSIZE]';
		var: #target declareC: 'char target[STRSIZE]';
		var: #localPool declareC: 'apr_pool_t* localPool';
		var: #localCtx declareC: 'svn_client_ctx_t* localCtx';
		var: #err declareC: 'svn_error_t *err';
		var: #propval declareC: 'const svn_string_t *propval';
		var: #newPropName declareC: 'const svn_string_t *newPropName'.
	self primitive: 'svnAddPropertyWithValueTo'
		parameters: #(#Oop #Oop #Oop ).
		
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Parse property, value and target'.
	self 
		copyOopString: propertyOop
		toCString: property
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: property.
	self 
		copyOopString: valueOop
		toCString: value
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: value.
	self 
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	
	self cCode: 'propval = svn_string_create(value, localPool)'.
	self cCode: 'newPropName = svn_string_create(property, localPool)'.
	
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: svn_client_propset2'.
	err := self cCode: ' svn_client_propset2(newPropName->data,
							 propval,
							 target,
							 FALSE, //do not recurse
							 TRUE, //no validy checking
							 localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Exit'! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rt 4/23/2008 11:07'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop 
	| url path revision err localCtx localPool resultStatus |
	self export: true.
	self
		var: #url 			declareC: 'char url[STRSIZE]';
		var: #path 			declareC: 'char path[STRSIZE]';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx';
		var: #revision		declareC: 'svn_opt_revision_t revision';
		var: #err			declareC: 'svn_error_t *err';
		var: #resultStatus	declareC: 'int resultStatus'.
	self primitive: 'svnCheckoutHeadRevisionFromTo'
		parameters: #(#Oop #Oop ).
		
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self 
		writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self cCode: 'revision.kind = svn_opt_revision_head'.
	self 
		writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Parse url and path'.
	self 
		copyOopString: aURLOop
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	self 
		copyOopString: aPathOop
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: path.
	self 
		writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: svn_client_checkout2'.
	err := self cCode: 'svn_client_checkout2(
		NULL,				
		url,
		path,
		&revision,
		&revision,
		TRUE,
		FALSE,
		localCtx, localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err.].
	self freeLocalPool: (self cCode: '&localPool').
	self 
		writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Exit'.
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rt 4/23/2008 11:22'!
svnCheckoutRevisionByNumber: aNumberOop from: aURLOop to: aPathOop 
	| err revisionNumber url path revision localPool localCtx resultStatus |
	self export: true.
	self
		var: #revisionNumber declareC: 'long int revisionNumber';
		var: #url declareC: 'char url[STRSIZE]';
		var: #path declareC: 'char path[STRSIZE]';
		var: #localPool declareC: 'apr_pool_t* localPool';
		var: #localCtx declareC: 'svn_client_ctx_t* localCtx';
		var: #revision declareC: 'svn_opt_revision_t revision';
		var: #err declareC: 'svn_error_t *err';
		var: #resultStatus	declareC: 'int resultStatus'.
	self primitive: 'svnCheckoutRevisionByNumberFromTo'
		parameters: #(#Integer #Oop #Oop ).
		
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
		
	self writeTextToOutputFile: '#svnCheckoutRevisionByNumber: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	self writeIntToOutputFile: revisionNumber.
	self
		cCode: 'revision.kind = svn_opt_revision_number';
		cCode: 'revision.value.number = revisionNumber'.
	self 
		copyOopString: aURLOop
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	self 
		copyOopString: aPathOop
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: path.
	
	self writeTextToOutputFile: 'svnCheckoutRevisionByNumber: svn_client_checkout2'.
	err := self cCode: 'svn_client_checkout2(
		NULL,				
		url,
		path,
		&revision,
		&revision,
		TRUE,
		FALSE,
		localCtx, localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCheckoutRevisionByNumber: Exit'.
	
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn cleanup' stamp: 'rt 4/21/2008 16:42'!
svnCleanupDirectory: directory

	| dir err localPool localCtx |
	self export: true.
	self 
		var: #dir		declareC: 'char dir[STRSIZE]';
		var: #err 		declareC: 'svn_error_t *err';
		var: #localPool	declareC: 'apr_pool_t* localPool';
		var: #localCtx	declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnCleanupDirectory' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Parse directory'.
	self 
		copyOopString: directory
		toCString: dir
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: dir.
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Call subversion'.
	err := self cCode: 'svn_client_cleanup(
		dir,
		localCtx,
		localPool)'.
	err ifTrue: [self handleError: err].
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCleanupDirectory: Exit'.
	^directory! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'cop 4/30/2008 17:40'!
svnCommit: anArrayOfStrings WithMessage: aMessageString

	| arraySize localPool localCtx err resultStatus logMessage commitInfoP copiedTargets temporaryPath arrayPtr |
	self export: true.
	self
		var: #localPool			declareC: 'apr_pool_t *localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t *localCtx';
		var: #err 				declareC: 'svn_error_t *err';
		var: #resultStatus		declareC: 'int resultStatus';
		var: #logMessage 		declareC: 'char logMessage[STRSIZE]';
		var: #commitInfoP		declareC: 'svn_commit_info_t *commitInfoP';
		var: #copiedTargets		declareC: 'apr_array_header_t *copiedTargets';
		var: #arrayPtr 			declareC: 'char **arrayPtr';		"This pointer has the wrong type. It references sqInts!!!!!!"
		var: #temporaryPath 	declareC: 'char temporaryPath[STRSIZE]';
		var: #arraySize 		declareC: 'int arraySize'.
	self primitive: 'svnCommitWithMessage' parameters: #(Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Parse variables'.
	"copy targets"
	arraySize := interpreterProxy slotSizeOf: anArrayOfStrings.
	arrayPtr := interpreterProxy firstIndexableField: anArrayOfStrings.
	copiedTargets := self cCode: 'apr_array_make (localPool, arraySize, sizeof (char*))'.
	0 to: arraySize - 1 do: [:index |
		self
			copyOopString: (arrayPtr at: index)
			toCString: temporaryPath
			ofLength: (self cCode: 'STRSIZE').
		self cCode: 'APR_ARRAY_PUSH (copiedTargets, char*) = apr_pstrdup( localPool, temporaryPath)'].
	
	"parse message"
	self
		copyOopString: aMessageString
		toCString: logMessage
		ofLength: (self cCode: 'STRSIZE').
	self cCode: 'localCtx->log_msg_baton2 = (void *) ( apr_pstrdup (localPool, logMessage) )'.
	
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Create required structures'.
	"set callback function"
	self cCode: 'localCtx->log_msg_func2 = commitCallbackToSetMessageAndMessageFileFromItemsAndMessageBatonWithPool'.
	"create commit info"
	commitInfoP := self cCode: 'svn_create_commit_info(localPool)'.
		
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Call Subversion'.
	err := self cCode: 'svn_client_commit3 (
		&commitInfoP,	/* commit_info_p, */
		copiedTargets,	/* targets to commit */
		TRUE,			/* recurse */
		FALSE,			/* do not keep_locks */
		localCtx, localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
				self handleError: err].
	
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCommit:WithMessage: Exit'.
	^ interpreterProxy integerObjectOf: resultStatus.! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'cop 4/30/2008 13:33'!
svnCreateProject: aName OnRepository: aUrl

	| projectName repositoryUrl fullUrl err commitInfo logMessage pathAprArray localCtx localPool resultStatus |
	self export: true.
	self
		var: #projectName			declareC: 'char projectName[STRSIZE]';
		var: #repositoryUrl 			declareC: 'char repositoryUrl[STRSIZE]';
		var: #fullUrl 				declareC: 'char *fullUrl';
		var: #err 					declareC: 'svn_error_t *err';
		var: #commitInfo			declareC: 'svn_commit_info_t *commitInfo';
		var: #logMessage 			declareC: 'const char *logMessage';
		var: #pathAprArray		declareC: 'apr_array_header_t *pathAprArray';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx';
		var: #localPool				declareC: 'apr_pool_t *localPool'.
	self primitive: 'svnCreateProjectOnRepository' parameters: #(Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnCreateProject:OnRepository: Entered'.
	
	"parse the name and the url"
	self
		copyOopString: aName
		toCString: projectName
		ofLength: (self cCode: 'STRSIZE').
	self
		copyOopString: aUrl
		toCString: repositoryUrl
		ofLength: (self cCode: 'STRSIZE').
		
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	"compute projects full url and put it in an array (mkdir needs it)"
	fullUrl := self cCode: 'svn_path_url_add_component(repositoryUrl, projectName, localPool)'.
	self writeTextToOutputFile: fullUrl.
	pathAprArray := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (pathAprArray, char*) = fullUrl'.
	
	"create the commit information"
	logMessage := self cCode: 'apr_psprintf (localPool, "Repository: Create project named %s", projectName)'.
	self
		cCode: 'localCtx->log_msg_func2 = commitCallbackToSetMessageAndMessageFileFromItemsAndMessageBatonWithPool';
		cCode: 'localCtx->log_msg_baton2 = (void *) logMessage'.
	
	"call svn"
	err := self cCode: 'svn_client_mkdir2(
		&commitInfo,
		pathAprArray,
		localCtx,
		localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].
	
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'cop 4/30/2008 17:44'!
svnDeleteTargetsFromWorkingCopy: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count tempString localPool localCtx err |
	self export: true.
	self
		var: #squeakStrings declareC: 'char** squeakStrings';
		var: #targetsArray 	declareC: 'apr_array_header_t * targetsArray';
		var: #err 			declareC: 'svn_error_t *err';
		var: #tempString 	declareC: 'char tempString[STRSIZE]';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnDeleteTargetsFromWorkingCopy' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Parse variables'.
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	targetsArray := self cCode: 'apr_array_make (localPool, count, sizeof (char*))'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		self
			copyOopString: (squeakStrings at: listIndex)
			toCString: tempString
			ofLength: (self cCode: 'STRSIZE').
		self cCode: 'APR_ARRAY_PUSH (targetsArray, char*) = apr_pstrdup( localPool, tempString)'].
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Call subversion'.
	err := self 
				cCode: 'svn_client_delete2(
			NULL,			// because here all paths are lokal 
			targetsArray,
			TRUE,			/* delete also modified items and items which are not under
							revision control, give no error if any item does not exists */
			localCtx, localPool)'.
	err ifTrue: [self handleError: err].

	self writeTextToOutputFile: '#Free pool'.
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Exit'.
	^aOopCollectionOfOopTargets! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/4/2008 13:01'!
svnExistsRepositoryOnUrl: aUrl

	| url boolExists boolNeedsAuth |
	self export: true.
	self
		var: #url				declareC: 'char url[STRSIZE]';
		var: #boolExists			declareC: 'int boolExists';
		var: #boolNeedsAuth	declareC: 'int boolNeedsAuth'.
	self primitive: 'svnExistsRepositoryOnUrl' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnExistsRepositoryOnUrl: Entered'.
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self
		repositoryAtUrl: url
		Exists: (self cCode: '&boolExists')
		AndNeedsAuthentication: (self cCode: '&boolNeedsAuth').
	boolExists ifTrue: [^interpreterProxy trueObject].
	^interpreterProxy falseObject! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'cop 5/1/2008 09:48'!
svnGetBlameLinesFrom: targetOop StoreLinesIn: lineArray
	"returns an array like #(rev1 author1 date1 line1 ...)"
	
	| target cArray arrayOop ptr numberOfLines localPool localCtx err resultStatus |
	self export: true.
	self
		var: #target 			declareC: 'char target[STRSIZE]';
		var: #cArray 			declareC: 'char **cArray';
		var: #numberOfLines 	declareC: 'int numberOfLines';
		var: #ptr 				declareC: 'int *ptr';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx';
		var: #err 				declareC: 'svn_error_t *err';
		var: #resultStatus		declareC: 'int resultStatus'.
	self primitive: 'svnGetBlameLinesFromStoreLinesIn' parameters: #(Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Parse target'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.

	"get the filled array"
	err := self cCode: 'getBlameLinesContextTargetNumbersArray(localPool, localCtx, target, &numberOfLines, &cArray)'.
	"err := self cCode: 'getBlameLines(&localPool, &localCtx, target, &numberOfLines, &cArray)'."
	
	err
		ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].

	"Create a Squeak-Array in which the result can be returned"
	"arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfLines."
	
	numberOfLines ~= (interpreterProxy slotSizeOf: lineArray) ifTrue: [numberOfLines := 0].
	
	"Copy the entries into the Squeak-Array and free them"
	"ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfLines - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (cArray at: i)).
		self free: (cArray at: i)].
	self free: cArray."
	numberOfLines ~= 0
		ifTrue: [0 to: numberOfLines - 1 do: [:index |.
					self putString: (cArray at: index) in: lineArray at: index.
					self free: (cArray at: index)]].	
	self free: cArray.
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Exit'.
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rkrk 4/26/2008 01:19'!
svnGetCommitLogs: countOop from: targetOop to: revisionNumberOop storeInArray: resultArray

	| err revision startRevision endRevision endRevisionNumber arrayOfTheTarget arrayOfTheLogs count target localPool localCtx resultStatus |
	self export: true.
	self
		var: #err					declareC: 'svn_error_t *err';
		var: #revision				declareC: 'svn_opt_revision_t revision';
		var: #startRevision			declareC: 'svn_opt_revision_t startRevision';
		var: #endRevision 			declareC: 'svn_opt_revision_t endRevision';
		var: #endRevisionNumber	declareC: 'long int endRevisionNumber';
		var: #arrayOfTheTarget		declareC: 'apr_array_header_t *arrayOfTheTarget';
		var: #arrayOfTheLogs		declareC: 'apr_array_header_t *arrayOfTheLogs';
		var: #count 				declareC: 'int count';
		var: #target 				declareC: 'char target[STRSIZE]';
		var: #localPool				declareC: 'apr_pool_t *localPool';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx';
		var: #resultStatus			declareC: 'int resultStatus'.
	
	self primitive: 'svnGetCommitLogsFromToStoreInArray' parameters: #(Integer Oop Integer Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Setup variables'.

	self cCode: 'revision.kind = svn_opt_revision_unspecified'.	
	self cCode: 'startRevision.kind = svn_opt_revision_number'.
	self cCode: 'startRevision.value.number = 0'.	
	self cCode: 'endRevision.kind = svn_opt_revision_number'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse number of end revision:'.
	endRevisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
	self writeIntToOutputFile: endRevisionNumber.
	self cCode: 'endRevision.value.number = endRevisionNumber'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse size of result array:'.
	self writeIntToOutputFile: (interpreterProxy integerValueOf: countOop).
	count := 4 *  (interpreterProxy integerValueOf: countOop).
	self writeIntToOutputFile: count.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse the target:'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	arrayOfTheTarget := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (arrayOfTheTarget, char*) = apr_pstrdup(localPool, target)'.

	"initialize the log array"
	arrayOfTheLogs := self cCode: 'apr_array_make (localPool, 0, sizeof(char*))'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Call subversion'.
	err := self cCode: 'svn_client_log3(
		arrayOfTheTarget,
		&revision,
		&startRevision,
		&endRevision,
		0,
		FALSE,
		FALSE,
		getCommitLogCallbackWithBatonForPathsAtRevisionForAuthorAndDateAndWithMessageAllAllocatedInPool,
		(void *) &arrayOfTheLogs,
		localCtx, localPool)'.
		
	"some error handling"
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err.
		self freeLocalPool: (self cCode: '&localPool').
		^ interpreterProxy integerObjectOf: resultStatus].
	(self cCode: 'count !!= arrayOfTheLogs->nelts') ifTrue: [
		self writeTextToOutputFile: 'svnGetCommitLogsFromToStoreInArray: That is crash prevention!! Your array has the wrong size.'.
		self writeIntToOutputFile: count.
		self writeIntToOutputFile: (self cCode: 'arrayOfTheLogs->nelts').
		self freeLocalPool: (self cCode: '&localPool').
		^ interpreterProxy integerObjectOf: resultStatus].
	
	self writeTextToOutputFile: 'svnGetCommitLogsFromToStoreInArray: Copy targets'.
	count ~= 0
		ifTrue: [0 to: count - 1 do: [:index |
					self writeTextToOutputFile: (self cCode: '((char**)arrayOfTheLogs->elts)[index]').
					self putString: (self cCode: '((char**)arrayOfTheLogs->elts)[index]') in: resultArray at: index]].	

	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Return the result'.
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'cop 5/1/2008 09:49'!
svnGetCountOfBlameLinesFrom: targetOop StoreCountIn: countArray
	
	| target cArray numberOfLines localPool localCtx err resultStatus |
	self export: true.
	self
		var: #target 			declareC: 'char target[STRSIZE]';
		var: #cArray 			declareC: 'char **cArray';
		var: #numberOfLines 	declareC: 'int numberOfLines';
		var: #ptr 				declareC: 'int *ptr';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx';
		var: #err 				declareC: 'svn_error_t *err';
		var: #resultStatus		declareC: 'int resultStatus'.
	self primitive: 'svnGetCountOfBlameLinesFromStoreCountIn' parameters: #(Oop Array).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Parse target'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.

	"get the filled array"
	err := self cCode: 'getBlameLinesContextTargetNumbersArray(localPool, localCtx, target, &numberOfLines, &cArray)'.
	
	err
		ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].
	
	self free: cArray.
	countArray at: 0 put: (interpreterProxy integerObjectOf: numberOfLines).
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnGetBlameLinesFrom:StoreLinesIn: Exit'.
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rkrk 4/26/2008 03:12'!
svnGetCountOfCommitLogsFrom: targetOop To: revisionNumberOop StoreCountIn: countArray

	| err revision startRevision endRevision endRevisionNumber commitLogCount arrayOfTheTarget target localCtx localPool resultStatus |
	self export: true.
	self
		var: #err					declareC: 'svn_error_t *err';
		var: #revision				declareC: 'svn_opt_revision_t revision';
		var: #startRevision			declareC: 'svn_opt_revision_t startRevision';
		var: #endRevision 			declareC: 'svn_opt_revision_t endRevision';
		var: #endRevisionNumber	declareC: 'long int endRevisionNumber';
		var: #commitLogCount		declareC: 'int commitLogCount';
		var: #arrayOfTheTarget		declareC: 'apr_array_header_t *arrayOfTheTarget';
		var: #target 	 			declareC: 'char target[STRSIZE]';
		var: #localPool				declareC: 'apr_pool_t *localPool';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx';
		var: #resultStatus			declareC: 'int resultStatus'.
					
	self primitive: 'svnGetCountOfCommitLogsFromToStoreCountIn' parameters: #(Oop Integer Array).
		
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Setup variables'.
	
	commitLogCount := 0.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.	
	self cCode: 'startRevision.kind = svn_opt_revision_number'.
	self cCode: 'startRevision.value.number = 0'.
	self cCode: 'endRevision.kind = svn_opt_revision_number'.
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Parse number of end revision:'.
	endRevisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
	self writeIntToOutputFile: endRevisionNumber.
	self cCode: 'endRevision.value.number = endRevisionNumber'.
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Parse the target:'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	arrayOfTheTarget := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (arrayOfTheTarget, char*) = apr_pstrdup(localPool, target)'.
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: array currupted ?'.
	self writeIntToOutputFile: (self cCode: 'arrayOfTheTarget->nelts').
	self writeTextToOutputFile: (self cCode: '((char**)arrayOfTheTarget->elts)[0]').

	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Call subversion'.
	err := self cCode: 'svn_client_log3(
		arrayOfTheTarget,
		&revision,
		&startRevision,
		&endRevision,
		0,
		FALSE,
		FALSE,
		commitLogCountingCallbackWithBatonForPathsAtRevisionForAuthorAndDateAndWithMessageAllAllocatedInPool,
		(void *) &commitLogCount,
		localCtx, localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFrom:To:StoreCountIn: Return the result:'.
	self writeIntToOutputFile: commitLogCount.
	self freeLocalPool: (self cCode: '&localPool').
	countArray at: 0 put: (interpreterProxy integerObjectOf: commitLogCount).
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'cop 4/30/2008 13:41'!
svnGetCountOfPropertiesOn: pathOop StoreCountIn: countArray

	| pathPtr truepath err props revision localCtx localPool count targetNode debugOutput resultStatus |
	self export: true.
	self
		var: #pathPtr			declareC: 'char pathPtr[STRSIZE]';
		var: #debugOutput 		declareC: 'char *debugOutput';
		var: #truepath 			declareC: 'const char *truepath';
		var: #err 				declareC: 'svn_error_t *err';
		var: #props 			declareC: 'apr_array_header_t *props';
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #count 			declareC: 'int count';
		var: #localCtx 			declareC: 'svn_client_ctx_t *localCtx';
		var: #localPool 			declareC: 'apr_pool_t *localPool';
		var: #targetNode		declareC: 'svn_client_proplist_item_t *targetNode';
		var: #resultStatus		declareC: 'int resultStatus'.
	self primitive: 'svnGetCountOfPropertiesOnStoreCountIn' parameters: #(Oop Array).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetCountOfPropertiesOn:StoreCountIn: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: (self cCode:'"parse path"').
	
	self
		copyOopString: pathOop
		toCString: pathPtr
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: pathPtr.
	self cCode: 'svn_opt_parse_path(&revision, &truepath, pathPtr, localPool)'.
	self writeTextToOutputFile: truepath.
	
	self writeTextToOutputFile: '#svnGetCountOfPropertiesOn: Call subversion'.
	err := self cCode: 'svn_client_proplist2(
		&props,
		truepath,
		&revision,
		&revision,
		FALSE,
		localCtx, localPool)'.
	
	self writeTextToOutputFile: '#svnGetCountOfPropertiesOn:StoreCountIn: Read properties'.
	count := 0.
	err
		ifTrue: [resultStatus := self cCode: 'err->apr_err'.
			self handleError: err]
		ifFalse: [(self cCode: 'props->nelts = 1')
			ifFalse: [debugOutput := '#svnGetCountOfPropertiesOn:StoreCountIn: ERROR: Wrong count of targets']
			ifTrue: [targetNode := self cCode: '((svn_client_proplist_item_t**)props->elts)[0]'.
				targetNode
					ifFalse: [debugOutput := '#svnGetCountOfPropertiesOn: Target without properties']
					ifTrue: [debugOutput := (self cCode: 'targetNode->node_name->data').
						count := self cCode: 'apr_hash_count (targetNode->prop_hash)']].
			self writeTextToOutputFile: debugOutput].
	
	self writeIntToOutputFile: count.
	self writeTextToOutputFile: '#svnGetCountOfPropertiesOn: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	countArray at: 0 put: (interpreterProxy integerObjectOf: count).
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'cop 4/30/2008 13:42'!
svnGetPropertiesOf: pathOop StoreInArray: resultArray

	| pathPtr truepath err props revision count targetNode localCtx localPool index hi resultStatus |
	self export: true.
	self
		var: #pathPtr			declareC: 'char pathPtr[STRSIZE]';
		var: #truepath 			declareC: 'const char *truepath';
		var: #err 				declareC: 'svn_error_t *err';
		var: #props 			declareC: 'apr_array_header_t *props';
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #count				declareC: 'int count';
		var: #index				declareC: 'int index';
		var: #hi				declareC:  'apr_hash_index_t *hi';
		var: #targetNode		declareC: 'svn_client_proplist_item_t *targetNode';
		var: #localCtx 			declareC: 'svn_client_ctx_t *localCtx';
		var: #localPool 			declareC: 'apr_pool_t *localPool';
		var: #resultStatus		declareC: 'int resultStatus'.
	self primitive: 'svnGetPropertiesOfStoreInArray' parameters: #(Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile:'#svnGetPropertiesOf:StoreInArray: Parse path'.
	self
		copyOopString: pathOop
		toCString: pathPtr
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: pathPtr.
	self cCode: 'svn_opt_parse_path(&revision, &truepath, pathPtr, localPool)'.
	self writeTextToOutputFile: truepath.
	
	err := self cCode: 'svn_client_proplist2(
		&props,
		truepath,
		&revision,
		&revision,
		FALSE,
		localCtx, localPool)'.
	err
		ifTrue: [resultStatus := self cCode: 'err->apr_err'.
				self handleError: err.
				self freeLocalPool: (self cCode: '&localPool').
				^ interpreterProxy integerObjectOf: resultStatus].
	(self cCode: 'props->nelts = 1')
		ifFalse: [self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: ERROR: Wrong count of targets'.
				self freeLocalPool: (self cCode: '&localPool').
				"interpreterProxy primitiveFail. ?"
				^ interpreterProxy integerObjectOf: resultStatus].
	targetNode := self cCode: '((svn_client_proplist_item_t**)props->elts)[0]'.
	targetNode
		ifFalse: [self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: No properties'.
				self freeLocalPool: (self cCode: '&localPool').
				"interpreterProxy primitiveFail. ?"
				^ interpreterProxy integerObjectOf: resultStatus].
	self writeTextToOutputFile: (self cCode: 'targetNode->node_name->data').
	count := self cCode: 'apr_hash_count (targetNode->prop_hash)'.
	
	count * 2 = (interpreterProxy slotSizeOf: resultArray)
		ifFalse: [self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: ERROR: Wrong count of properties'.
				self freeLocalPool: (self cCode: '&localPool').
				"interpreterProxy primitiveFail. ?"
				^ interpreterProxy integerObjectOf: resultStatus].

	self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: Copy content of hash'.
	index := 0.
	hi := self cCode: 'apr_hash_first(localPool, targetNode->prop_hash)'.
	[hi] whileTrue: [
		self
			copyKeyAndValueOfAprHashIndex: hi
			in: resultArray
			at: index.
		index := index + 2. "Store both key and value in array"
		hi := self cCode: 'apr_hash_next(hi)'].
	
	self writeTextToOutputFile: '#svnGetPropertiesOf:StoreInArray: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/26/2008 00:35'!
svnInfoCbBaton: baton Target: target Info: info Pool: cbPool
"baton is nil. The array should be stores in callbackBatonOop"

	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #info type: 'const svn_info_t *';
		var: #cbPool type: 'apr_pool_t *'.
	
	self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: entered'.

	interpreterProxy success: (interpreterProxy isArray: callbackBatonOop).
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: no array...'.].
	
	self writeTextToOutputFile: (self cCode: 'info->URL').
		
	self putString:  	(self cCode: 'info->repos_root_URL') 		in: callbackBatonOop at: 0.
	"Do not consider revision kind at 1"
	self putRevision: 	(self cCode: 'info->rev') 					in: callbackBatonOop at: 2.
	self putString: 	(self cCode: 'info->repos_UUID') 			in: callbackBatonOop at: 3.
	"Do not consider revision kind at 4"
	self putRevision: 	(self cCode: 'info->last_changed_rev') 		in: callbackBatonOop at: 5.
	self putAprDate: 	(self cCode: 'info->last_changed_date') 	in: callbackBatonOop at: 6.
	self putString: 	(self cCode: 'info->last_changed_author') 	in: callbackBatonOop at: 7.
	(self cCode: 'info->has_wc_info')
		ifTrue: [self putSchedule: 	(self cCode: 'info->schedule') 	in: callbackBatonOop at: 8].
	"^ <#(repositoryUrl revision repositoryUUID lastChangedRev lastChangeDate lastChangedAuthor)>"
	^ self cCode: 'SVN_NO_ERROR'.
	

     " if (info->text_time)
        SVN_ERR(svn_cl__info_print_time(info->text_time, 
                                        _('Text Last Updated'), pool));
      
      if (info->prop_time)
        SVN_ERR(svn_cl__info_print_time(info->prop_time, 
                                        _('Properties Last Updated'), pool));
      
      if (info->checksum) 
        SVN_ERR(svn_cmdline_printf(pool, _('Checksum: %s\n'),
                                   info->checksum));
      
      if (info->conflict_old) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Previous Base File: %s\n'),
                                   svn_path_local_style(info->conflict_old,
                                                        pool)));
 
      if (info->conflict_wrk) 
        SVN_ERR(svn_cmdline_printf
                (pool, _('Conflict Previous Working File: %s\n'),
                 svn_path_local_style(info->conflict_wrk, pool)));
      
      if (info->conflict_new) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Current Base File: %s\n'),
                                   svn_path_local_style(info->conflict_new,
                                                        pool)));
 
      if (info->prejfile) 
        SVN_ERR(svn_cmdline_printf(pool, _('Conflict Properties File: %s\n'),
                                   svn_path_local_style(info->prejfile,
                                                        pool)));"! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'cop 4/30/2008 13:43'!
svnInfoForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop storeInArray: resultArrayOop

	"This can currently only be used to access the state of the element in the working copy"
	| target err truepath pegRevision revision localPool localCtx resultStatus revisionKind revisionNumber |
	self export: true.
	self
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #revisionKind 		declareC: 'int revisionKind';
		var: #revisionNumber 	declareC: 'svn_revnum_t revisionNumber';
		var: #pegRevision 		declareC: 'svn_opt_revision_t pegRevision';
		var: #truepath 			declareC: 'const char *truepath';
		var: #err 				declareC: 'svn_error_t *err';
		var: #target 	 		declareC: 'char target[STRSIZE]';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx';
		var: #resultStatus 		declareC: 'int resultStatus'.
	self primitive: 'svnInfoForTargetRevisionKindRevisionNumberStoreInArray' parameters: #(Oop Oop Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnInfoForTarget:storeInArray:  Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	"Prepare target string"
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self cCode: 'svn_opt_parse_path(&pegRevision, &truepath, target, localPool)'.
	"Set the revisions for retrieving working copy informations"
	"self cCode: 'pegRevision.kind = svn_opt_revision_unspecified'."
	revisionKind := interpreterProxy integerValueOf: revisionKindOop.
	self cCode: 'revision.kind = revisionKind'.
	(self cCode: 'revisionKind == svn_opt_revision_number')
		ifTrue: [revisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
			self cCode: 'revision.value.number = revisionNumber'].
	
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 1'.].
	
	"Svn call. Don't use the baton. use instVar callbackBatonOop instead'"
	callbackBatonOop := resultArrayOop.
	err := self cCode: 'svn_client_info (
		truepath,
		&pegRevision, 					/* peg-revision */
		&revision, 						/* revision */
		svnInfoCbBatonTargetInfoPool,		/* callback */
		NULL, 							/* baton, we use callbackBatonOop */
		FALSE, 							/* no recurse */
		localCtx, localPool)'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err.
		self freeLocalPool: (self cCode: '&localPool').
		callbackBatonOop := nil.
		^ interpreterProxy integerObjectOf: resultStatus].
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 2'.].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 0 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 0 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy fetchPointer: 1 ofObject:  callbackBatonOop).

	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 3 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 3 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy fetchPointer: 4 ofObject:  callbackBatonOop).
interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 3'.].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 6 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 6 ofObject:  callbackBatonOop)).
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 7 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 7 ofObject:  callbackBatonOop)).
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 8 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 8 ofObject:  callbackBatonOop)).
	callbackBatonOop := nil.	"Reset"
interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 4'.].
	self writeTextToOutputFile: '#svnInfoForTarget:storeInArray:  Return to squeak...'.
	
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'rt 4/23/2008 15:25'!
svnProject: projectName On: aUrl Exists: resultArray

	| url dirName err revision valueForHash localCtx dirents hashForBaton localPool resultStatus |
	self export: true.
	self
		var: #url 			declareC: 'char url[STRSIZE]';
		var: #dirName 		declareC: 'char dirName[STRSIZE]';
		var: #err			declareC: 'svn_error_t *err';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #valueForHash	declareC: 'svn_dirent_t *valueForHash';
		var: #localCtx		declareC: 'svn_client_ctx_t *localCtx';
		var: #dirents 		declareC: 'apr_uint32_t dirents'; "we use the baton"
		var: #hashForBaton	declareC: 'apr_hash_t *hashForBaton';
		var: #localPool		declareC: 'apr_pool_t *localPool';
		var: #resultStatus	declareC: 'int resultStatus'.
	self primitive: 'svnProjectOnExists' parameters: #(Oop Oop Array).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnProject:On:Exists: Entered'.
	
	"parse the repository url"
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	
	(self cCode: 'svn_path_is_url(url)')
		ifFalse: [resultArray at: 0 put: interpreterProxy falseObject.
			^ interpreterProxy integerObjectOf: resultStatus].
	
	"parse the name of the project"
	self
		copyOopString: projectName
		toCString: dirName
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: dirName.
	
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	"create the baton with the information we need"
	valueForHash := self cCode: 'apr_palloc( localPool , sizeof(svn_dirent_t *) )'.
	self cCode: 'valueForHash->kind = svn_node_none'.
	hashForBaton := self cCode: 'apr_hash_make(localPool)'.
	"store data in baton"
	self cCode: 'apr_hash_set(
		hashForBaton,
		(void*) dirName,
		APR_HASH_KEY_STRING,
		(void*) valueForHash)'.
	
	"find out if the project exists"
	self cCode: 'revision.kind = svn_opt_revision_head'.
	err := self cCode: 'svn_client_list(
		url,
		&revision,
		&revision,
		FALSE,		/*recurse*/
		dirents,		/*memory to store directory information*/
		FALSE,		/*fetch_locks*/
		computeStatusForEntryInBatonWithPathDirentLockAbsPathAndPool, /*callback*/
		(void*) &hashForBaton,
		localCtx, localPool)'.
	err
		ifTrue: [resultStatus := self cCode: 'err->apr_err'."?"
			self handleError: err.
			self freeLocalPool: (self cCode: '&localPool').
			resultArray at: 0 put: interpreterProxy falseObject.
			^ interpreterProxy integerObjectOf: resultStatus].
	
	"parse data back to something we can interprete and interprete it"
	valueForHash := self cCode: '(svn_dirent_t *) apr_hash_get(
		hashForBaton,
		dirName,
		APR_HASH_KEY_STRING)'.
	(self cCode: 'valueForHash->kind !!= svn_node_dir')
		ifTrue: [resultArray at: 0 put: interpreterProxy falseObject]
		ifFalse: [resultArray at: 0 put: interpreterProxy trueObject.].

	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/4/2008 13:00'!
svnRequireAuthenticationAtRepositoryOnUrl: aUrl

	| url boolExists boolNeedsAuth |
	self export: true.
	self
		var: #url				declareC: 'char url[STRSIZE]';
		var: #boolExists			declareC: 'int boolExists';
		var: #boolNeedsAuth	declareC: 'int boolNeedsAuth'.
	self primitive: 'svnRequireAuthenticationAtRepositoryOnUrl' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnRequireAuthenticationAtRepositoryOnUrl: Entered'.
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self
		repositoryAtUrl: url
		Exists: (self cCode: '&boolExists')
		AndNeedsAuthentication: (self cCode: '&boolNeedsAuth').
	boolNeedsAuth ifTrue: [^interpreterProxy trueObject].
	^interpreterProxy falseObject! !

!SqueakSVNPlugin methodsFor: 'svn revert' stamp: 'cop 4/30/2008 13:44'!
svnResolvedTarget: targetOop

	| target err localPool localCtx |
	self export: true.
	self
		var: #target 			declareC: 'char target[STRSIZE]';
		var: #err 				declareC: 'svn_error_t *err';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnResolvedTarget' parameters: #(Oop).

	self writeTextToOutputFile: '#svnResolvedTarget: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self copyOopString: targetOop toCString: target ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: 'Copied target:'.
	self writeTextToOutputFile: target.

	self writeTextToOutputFile: 'Try to set to resolved'.
	err := self cCode: 'svn_client_resolved (
		&target,
		TRUE, 	/* recurse */
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
		
	self writeTextToOutputFile: '#svnResolvedTarget: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ targetOop! !

!SqueakSVNPlugin methodsFor: 'svn revert' stamp: 'rt 4/30/2008 18:02'!
svnRevertTargets: targets

	| numberOfTargets squeakStrings targetsArray tempString err localPool localCtx |
	self export: true.
	self
		var: #squeakStrings 	declareC: 'char** squeakStrings';
		var: #numberOfTargets declareC: 'int numberOfTargets';
		var: #targetsArray 		declareC: 'apr_array_header_t * targetsArray';
		var: #tempString 		declareC: 'char tempString[STRSIZE]';
		var: #err 				declareC: 'svn_error_t *err';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnRevertTargets' parameters: #(Oop).

	self writeTextToOutputFile: '#svnRevertTargets: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	self writeTextToOutputFile: 'Count targets'.
	numberOfTargets := interpreterProxy slotSizeOf: targets.
	
	self writeTextToOutputFile: 'Create apr_array'.
	targetsArray := self cCode: 'apr_array_make (localPool, numberOfTargets, sizeof (char*))'.

	self writeTextToOutputFile: 'Copy targets'.
	squeakStrings := interpreterProxy firstIndexableField: targets.
	0 to: numberOfTargets-1 do: [:i |
		self
			copyOopString: (squeakStrings at: i)
			toCString: tempString
			ofLength: (self cCode: 'STRSIZE').
		self writeTextToOutputFile: tempString.
		self cCode: 'APR_ARRAY_PUSH (targetsArray, char*) = (char*) apr_pstrdup (localPool, tempString)'].
	
	self writeTextToOutputFile: 'Try to revert targets'.
	err := self cCode: 'svn_client_revert (
		targetsArray,
		TRUE, 	/* recurse */
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
		
	self writeTextToOutputFile: '#svnRevertTargets: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ targets! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 4/27/2008 16:38'!
svnRevisionFromRevisionKind: revisionKindOop revisionNumber: revisionNumberOop

	| revisionNumber revision revisionKind |
	self returnTypeC: 'svn_opt_revision_t'.
	self
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #revisionKind 	declareC: 'int revisionKind';
		var: #revisionNumber declareC: 'svn_revnum_t revisionNumber'.
		
	revisionKind := interpreterProxy integerValueOf: revisionKindOop.
	self cCode: 'revision.kind = revisionKind' .
	(self cCode: 'revisionKind == svn_opt_revision_number')
		ifTrue: [
			self writeTextToOutputFile: 'Setting revision'. 
			revisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
			self cCode: 'revision.value.number = revisionNumber'].
	^ revision! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/27/2008 15:09'!
svnStatusCbBaton: baton target: target status: status
"baton is nil. The array should be stores in callbackBatonOop"

	self returnTypeC: 'void'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #status type: 'svn_wc_status2_t *'.
	
	self writeTextToOutputFile: 'svnStatusCbBaton:target:status: entered'.

	interpreterProxy success: (interpreterProxy isArray: callbackBatonOop).
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: no array...'.].
	
	self
		writeTextToOutputFile: 'Status for target';
		writeIntToOutputFile: (self cCode: 'status->text_status').
	
	(self cCode: 'strlen(targetString)')
		ifTrue: [ (self cCode: 'strcmp(target, targetString)')
				ifFalse: [self putStatus: (self cCode: 'status->text_status') in: callbackBatonOop at: 0]]
		ifFalse: [
			self writeTextToOutputFile: 'highest'.
			(interpreterProxy integerValueOf: (interpreterProxy fetchPointer: 0 ofObject: callbackBatonOop)) < (self cCode: 'status->text_status')
				ifTrue: [self putStatus: (self cCode: 'status->text_status') in: callbackBatonOop at: 0] ]
	! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/27/2008 15:50'!
svnStatusForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop storeInArray: resultArrayOop recursive: recursiveOop

	"This can currently only be used to access the state of the element in the working copy"
	| target err resultRev revision localPool localCtx recursiveBool resultStatus |
	self export: true.
	self
		var: #target 	 		declareC: 'char target[STRSIZE]';
		var: #err 			declareC: 'svn_error_t *err';
		var: #resultRev 		declareC: 'svn_revnum_t resultRev';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #localPool		declareC: 'apr_pool_t *localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t *localCtx';
		var: #recursiveBool 	declareC: 'int recursiveBool';
		var: #resultStatus 	declareC: 'int resultStatus'.
	self primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArrayRecursive' parameters: #(Oop Oop Oop Oop Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnStatusForTarget:storeInArray:  Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	"Prepare target string"
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	
	"using instVar is a bad solution. The strange query with the strcmp in the callback isnt very transparent either"
	recursiveBool := interpreterProxy booleanValueOf: recursiveOop.
	recursiveBool ifFalse: [
		self
			copyOopString: targetOop
			toCString: targetString "What is the target string????"
			ofLength: (self cCode: 'STRSIZE')].
	
	self
		writeTextToOutputFile: 'svn_client_status2';
		writeTextToOutputFile: target.
	
	"prepare parameters"
	resultRev := -1.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	
	callbackBatonOop := resultArrayOop.
	self putStatus: 0 in: callbackBatonOop at: 0.
	err := self cCode: 'svn_client_status2 (
		&resultRev, 						/* svn_revnum_t * */
		target,
		&revision,			 			/* const svn_opt_revision_t **/
		svnStatusCbBatontargetstatus, 	/* svn_wc_status_func2_t */
		NULL,							/* status_baton */
		recursiveBool,					/* recurse */
		TRUE,							/* get_all */
		TRUE, 							/* update, means contact repository for status*/
		TRUE, 							/* no_ignore??? */
		TRUE, 							/* ignore_externals */
		localCtx, localPool)'.
	self cCode: 'strcpy(targetString, "\0")'.
	err ifTrue: [resultStatus := self cCode: 'err->apr_err'.
		self handleError: err.
		self freeLocalPool: (self cCode: '&localPool').
		callbackBatonOop := nil.
		^ interpreterProxy integerObjectOf: resultStatus].
	callbackBatonOop := nil.
	self writeTextToOutputFile: 'svn_client_status2 - end of call'.

	self
		writeTextToOutputFile: 'result revision:';
		writeIntToOutputFile: resultRev.
		
	self writeTextToOutputFile: '#svnStatusForTarget:storeInArray:  Return to squeak...'.
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'cop 4/30/2008 11:45'!
svnUpdateTargets: aOopCollectionOfOopTargets toRevisionKind: revisionKindOop revisionNumber: revisionNumberOop beRecursive: boolOop

	| count cString revisionNumber localPool localCtx err resultStatus  revision arraySize arrayPtr temporaryPath copiedTargets revisionKind recurse |
	self export: true.
	self 
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx';
		var: #err 				declareC: 'svn_error_t *err';
		var: #resultStatus		declareC: 'int resultStatus';
		var: #revisionKind 		declareC: 'int revisionKind';
		var: #revisionNumber 	declareC: 'svn_revnum_t revisionNumber';
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #copiedTargets		declareC: 'apr_array_header_t *copiedTargets';
		var: #arrayPtr 			declareC: 'sqInt *arrayPtr';
		var: #temporaryPath 	declareC: 'char temporaryPath[STRSIZE]';
		var: #arraySize 		declareC: 'int arraySize';
		var: #recurse 			declareC: 'svn_boolean_t recurse'.

	self primitive: 'svnUpdateTargetsToRevisionKindRevisionNumberBeRecursive' parameters: #(Oop Oop Integer Oop).
	
	resultStatus := self cCode: '(int) SVN_NO_ERROR'.
	
	self writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateContext: localCtx InPool: localPool.
	
	"Prepare parameter:"
	copiedTargets :=	self
		aprArrayFromOopStrings: aOopCollectionOfOopTargets
		using: localPool.
	revision := self
		svnRevisionFromRevisionKind: revisionKindOop
		revisionNumber: revisionNumberOop.
	recurse  := interpreterProxy booleanValueOf: boolOop.
	self
		writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: beRecursive:';
		writeIntToOutputFile: recurse.
	
	"Call SVN"
	err := self cCode: 'svn_client_update2(
		NULL, 				/* do not use result_rev */
		copiedTargets,
		&revision,
		recurse,
		FALSE,				/* ignore externals */
		localCtx, localPool)'.
	err ifTrue: [
		resultStatus := self cCode: 'err->apr_err'.
		self handleError: err].

	self writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: resultStatus! !

!SqueakSVNPlugin methodsFor: 'svn authentication' stamp: 'cop 4/30/2008 13:50'!
usrCallbackForCredential: cred
	EmptyBaton: baton
	Realm: realm
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_username_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	
	self writeTextToOutputFile: 'usrCallbackForCredential: Entered'.
	
	self
		cCode: '(*cred) = (svn_auth_cred_username_t*) apr_pcalloc( localPool, sizeof(svn_auth_cred_username_t*))';
		cCode: '(*cred)->username = (char*) apr_pcalloc (localPool, sizeof(char) * STRSIZE)';
		cCode: '(*cred)->username = apr_pstrdup ( localPool, username )';
		cCode: '(*cred)->may_save = TRUE'.
		
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'debugging' stamp: 'cop 4/30/2008 13:56'!
writeIntToOutputFile: number
	
	| buffer |
	self static: true;
		export: true.
	self returnTypeC: 'void'.
	self var: #number type: 'int';
		var: #buffer declareC: 'char buffer[STRSIZE]'.
		
	self cCode: 'sprintf(buffer, "%d", number)'.
	self	writeTextToOutputFile: buffer! !

!SqueakSVNPlugin methodsFor: 'debugging' stamp: 'cop 4/30/2008 17:30'!
writeTextToOutputFile: text
	
	| datei |
	self static: true;
		export: true.
	self returnTypeC: 'void'.
	self var: #text declareC: 'const char* text';
		var: #datei declareC: 'FILE* datei'.
	
	datei := self cCode: 'fopen("SqueakSVNDebug.log", "a+")'.
	datei ifFalse: [self cCode: 'return'.].
	
	self cCode: 'fputs("SqueakSVNWrapper: ", datei)';
		cCode: 'fputs(text, datei)';
		cCode: 'fputc(''\n'', datei)';
		cCode: 'fclose(datei)'.! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rt 4/2/2008 13:40'!
writeToOutputFileText: textOop

	| text |
	self export: true.
	self var: #text declareC: 'char text[STRSIZE]'.
	self primitive: 'writeToOutputFileText' parameters: #(Oop).
	
	self
		copyOopString: textOop
		toCString: text
		ofLength: (self cCode: 'STRSIZE').
		
	self writeTextToOutputFile: text.! !

SmartSyntaxInterpreterPlugin subclass: #TestEnvPlg
	instanceVariableNames: 'pool ctx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!TestEnvPlg class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 00:15'!
declareCVarsIn: cg

	super declareCVarsIn: cg.

	self cCode: ''.
	cg
		var: #pool 		declareC: 'apr_pool_t *pool';
		var: #ctx 		declareC: 'svn_client_ctx_t *ctx'.
				
	cg
		addHeaderFile: '"svn_string.h"';
		addHeaderFile: '"svn_repos.h"';
		addHeaderFile: '"svn_client.h"';
		addHeaderFile: '"svn_cmdline.h"';
		addHeaderFile: '"svn_wc.h"';
		addHeaderFile: '"svn_pools.h"
#define STRSIZE 1024'.	"Another way how to use define?"! !

!TestEnvPlg methodsFor: 'pool and context' stamp: 'rt 4/13/2008 15:31'!
authPoolAndContext

	| provider creds providers |
	self
		var: #provider			declareC: 'svn_auth_provider_object_t *provider';
		var: #creds				declareC: 'svn_auth_cred_simple_t *creds';
		var: #providers			declareC: 'apr_array_header_t *providers'.

	creds := self cCode: 'apr_pcalloc(pool, sizeof(svn_auth_cred_simple_t*))'.
	providers := self cCode: 'apr_array_make (pool, 2, sizeof (svn_auth_provider_object_t *))'.

	self cCode: 'creds->username = "username\0"'.
	self cCode: 'creds->password = "password\0"'.
	self cCode: 'creds->may_save = FALSE'.
		
	self cCode: 'svn_auth_get_simple_prompt_provider (&provider,
										 pwdCallbackForCredentialNotificationBatonRealmUsernameMaySaveIndicatorAndPool,
										 (void *)creds,
										 0, pool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.

	self cCode: 'svn_auth_get_username_prompt_provider (&provider,
										 usrCallbackForCredentialNotificationBatonRealmMaySaveIndicatorAndPool,
										 (void *)creds,
										 0, pool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	self cCode: 'svn_auth_open (&ctx->auth_baton, providers, pool)'! !

!TestEnvPlg methodsFor: 'helper' stamp: 'rt 4/14/2008 00:27'!
copyOopString: oopString toCString: cString ofLength: cStringLength
	"copied from the SqueakSVNPlugin"

	self returnTypeC: 'void'.
	self var: cString type: 'char*'.
	
	((interpreterProxy stSizeOf: oopString) > cStringLength)
		ifTrue: [interpreterProxy success: false].
	self
		st: cString
		rn: (interpreterProxy arrayValueOf: oopString)
		cpy: (interpreterProxy stSizeOf: oopString).
	cString at: (interpreterProxy stSizeOf: oopString) put: (self cCode: '''\0''').! !

!TestEnvPlg methodsFor: 'pool and context' stamp: 'rt 4/13/2008 15:19'!
initializePoolAndContext

	| err status |
	self
		var: #err		declareC: 'svn_error_t *err';
		var: #status		declareC: 'apr_status_t status'.

	status := self cCode: 'apr_initialize()'.
	self cCode: 'svn_dso_initialize()'.
	self cCode: 'if (0 > atexit(apr_terminate)) return'.

	pool := self cCode: 'svn_pool_create(NULL)'.
	self cCode: 'svn_utf_initialize(pool)'.
  
	err := self cCode: 'svn_nls_init()'.
	err ifTrue: [self cCode: 'svn_error_clear(err)'].
	
	self cCode: 'svn_fs_initialize (pool)'.
	self cCode: 'svn_config_ensure (NULL, pool)'.
	self cCode: 'svn_client_create_context (&ctx, pool)'.
	self cCode: 'svn_config_get_config (&(ctx->config), NULL, pool)'.

	self cCode: '#ifdef WIN32

		if (getenv ("SVN_ASP_DOT_NET_HACK"))
		{
			svn_wc_set_adm_dir ("_svn", pool);
		}
	#endif'! !

!TestEnvPlg methodsFor: 'authentication' stamp: 'rt 4/13/2008 17:04'!
pwdCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	Username: username
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #username 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->password = ""';
		cCode: '(*cred)->may_save = FALSE'.
	^ self cCode: 'SVN_NO_ERROR'! !

!TestEnvPlg methodsFor: 'svn primitives' stamp: 'rt 4/13/2008 17:00'!
svnAdminCreateRepositoryOn: aPath

	| path reposP |
	self export: true.
	self
		var: #path 		declareC: 'char path[STRSIZE]';
		var: #reposP	declareC: 'svn_repos_t *reposP'.
	self primitive: 'svnAdminCreateRepositoryOn' parameters: #(Oop).
	
	self
		copyOopString: aPath
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
		
	self initializePoolAndContext.
	self authPoolAndContext.
		
	self cCode: 'svn_repos_create(
		&reposP,
		path,
		NULL,	//unused_1
		NULL,	//unused_2
		NULL,	//config
		NULL,	//fs_config,
		pool)'.
		
	self cCode: 'svn_pool_destroy(pool)'.
	pool := nil.
	ctx := nil.! !

!TestEnvPlg methodsFor: 'svn primitives' stamp: 'rt 4/13/2008 17:01'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop 
	| url path revision err |
	self export: true.
	self
		var: #url declareC: 'char url[STRSIZE]';
		var: #path declareC: 'char path[STRSIZE]';
		var: #revision declareC: 'svn_opt_revision_t revision';
		var: #err declareC: 'svn_error_t *err'.
	self primitive: 'svnCheckoutHeadRevisionFromTo'
		parameters: #(Oop Oop ).

	self cCode: 'revision.kind = svn_opt_revision_head'.
	self 
		copyOopString: aURLOop
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self 
		copyOopString: aPathOop
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
		
	self initializePoolAndContext.
	self authPoolAndContext.
	
	err := self cCode: 'svn_client_checkout2(
		NULL,				
		url,
		path,
		&revision,
		&revision,
		TRUE,
		FALSE,
		ctx, pool)'.	"error handling"
			
	self cCode: 'svn_pool_destroy(pool)'.
	pool := nil.
	ctx := nil.! !

!TestEnvPlg methodsFor: 'authentication' stamp: 'rt 4/13/2008 17:02'!
usrCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #username 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->may_save = FALSE'.
	^ self cCode: 'SVN_NO_ERROR'! !

Object subclass: #SqueakSVNPluginBuilder
	instanceVariableNames: 'vmMaker srcPath pathToDefDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 18:00'!
couldBeALegalSymbol: maybeASymbol

	^ (maybeASymbol includesAnyOf: {$-. $>. $<. $*. $/. $\. $". $). $[. $]. $$. $!!. $?. $|. $.. $:. $,. $;. $#. $'. $+. ${. $}. $%. $&. $=. $~. $@}) not! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'cop 4/28/2008 10:22'!
createPlugin

	self generatePluginCode.
	self generateDef! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 17:59'!
findFunctionsIn: aString startsWith: anIndicator

	| result posInd posEnd maybeASymbol end |
	result := OrderedCollection new.
	posInd := aString findString: anIndicator.
	posInd = 0 ifTrue: [^ result].
	posEnd := aString indexOf: $( startingAt: posInd.
	posEnd = 0 ifTrue: [^ result].
	
	maybeASymbol := aString copyFrom: posInd to: posEnd - 1.
	end := aString copyFrom: posEnd + 1 to: aString size.
	
	(maybeASymbol subStrings: ' ') size > 1
		ifTrue: [end := (maybeASymbol
					copyFrom: anIndicator size
					to: maybeASymbol size)
						, end]
		ifFalse: [(self couldBeALegalSymbol: maybeASymbol)
					ifTrue: [result add: maybeASymbol substrings first]].	
	
	result addAll: (self findFunctionsIn: anIndicator startsWith: end).
	^ result! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 12:06'!
findUnresolvedSymbols

	| file symbols |
	file := StandardFileStream
		readOnlyFileNamed: ((self vmMaker externalPluginsDirectoryFor: (Smalltalk
					classNamed: self pluginName))
			fullNameFor: self pluginName , '.c').
	
	symbols := OrderedCollection new.
	file contents linesDo: [:each |
		(each includes: $()
			ifTrue: [
				symbols addAll: (self findFunctionsIn: each startsWith: 'svn_').
				symbols addAll: (self findFunctionsIn: each startsWith: 'apr_')]].

	file close.
	^ symbols asSet! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/25/2008 15:06'!
generateDef

	| symbols file |
	symbols := self findUnresolvedSymbols.
	symbols addAll: self wrapperSymbols.
	
	(self pathToDefDir isNil or:
		[(FileDirectory default directoryExists: self pathToDefDir) not])
			ifTrue: [^ self error: 'The directory of the module definition file does not exists.'].
	
	(FileDirectory on: self pathToDefDir) deleteFileNamed: self nameOfDef.
	file := StandardFileStream fileNamed: self pathToDefDir , FileDirectory slash , self nameOfDef.
	
	file nextPutAll: 'EXPORTS'.
	symbols asSortedCollection do: [:eachSymbol |
		file nextPut: Character cr.
		file nextPut: Character lf.
		file nextPutAll: eachSymbol.].
	
	file close.! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 11:45'!
generatePluginCode

	self vmMaker generateMainVM.
	self vmMaker reinitializePluginsLists.
	self vmMaker internal: {} external: {self pluginName}.
	self vmMaker generateExternalPlugin: self pluginName! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:25'!
initialize

	self vmMaker: VMMaker default.
	self srcPath: (FileDirectory default directoryNamed: self vmMaker class sourceDirName) fullName.! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 10:43'!
nameOfDef

	^ 'squeakSVNWrapper.def'! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 10:35'!
pathToDefDir

	^ pathToDefDir! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/11/2008 10:35'!
pathToDefDir: aPath

	pathToDefDir := aPath! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:22'!
pluginName

	^'SqueakSVNPlugin'! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:22'!
srcPath

	^ self vmMaker sourceDirectory fullName! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:21'!
srcPath: aPath

	self vmMaker sourceDirectoryName: aPath! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:19'!
vmMaker

	^ vmMaker! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/10/2008 16:19'!
vmMaker: aVMMaker

	vmMaker := aVMMaker! !

!SqueakSVNPluginBuilder methodsFor: 'as yet unclassified' stamp: 'rt 4/25/2008 15:03'!
wrapperSymbols

	^ {'deleteTargetsFromWC'.
	'freeMemory'.
	'getHeadRevisionOf'.
	'getBlameLines'.
	'handleError'.
	'initialize'.
	'initializeWithParentPool'.
	'updateTargetsToHeadRevision'.
	'updateTargetsToRevisionByNumber'.
	'test'.
	'writeTextToOutputFile'.
	'writeIntToOutputFile'}! !
